UVA - 12563 Jin Ge Jin Qu hao (01背包变形)

  此题应该注意两个点,首先背包容量应该缩减为t-1,因为最长的歌不超过三分钟,而劲歌金曲有678s,所以肯定要留出这个时间来。其次注意优先级,保证唱的歌曲数目最多,在此前提下尽可能的延长时间。

  处理方法:开创结构体,在歌曲数目相等的时候,选取最长时间。

  注意:注意t的大小,t完全没有必要计算那么大的数据。 代码如下:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define N 10010
int w[55];
struct DP
{
    int song,tim;
}dp[N];
int main()
{
//    freopen("1.in.cpp","r",stdin);
    int T,n,t,ca=0,sum;
    cin>>T;
    while(T--)
    {
        cin>>n>>t;
        sum = 0;
        for(int i = 1; i <= n; i++) {
                cin>>w[i];
                sum += w[i];
        }
        if(t > sum){
            if(t < sum + 678) t = sum + 678;
            printf("Case %d: %d %d\n",++ca,n+1,t);
            continue;
        }
        t--;
        for(int i = 0;i < N;i++) dp[i].song = dp[i].tim = 0;
        for(int i = 1; i <= n; i++)
        {
            for(int j = t; j >= w[i]; j--)
            {
                if(dp[j-w[i]].song+1 > dp[j].song)
                {
                    dp[j].song = dp[j-w[i]].song + 1;
                    dp[j].tim = dp[j-w[i]].tim + w[i];
                }
                if(dp[j-w[i]].song+1 == dp[j].song)
                {
                    dp[j].tim = max(dp[j].tim,dp[j-w[i]].tim + w[i]);
                }
            }
        }
        printf("Case %d: %d %d\n",++ca,dp[t].song+1,dp[t].tim+678);
    }
    return 0;
}
时间: 2024-12-14 04:13:23

UVA - 12563 Jin Ge Jin Qu hao (01背包变形)的相关文章

UVA 12563 Jin Ge Jin Qu hao 01背包变形

基本的01背包,更新的时候保持背包里每一个元素的num最大然后time尽量长 CSDN也支持makedown了试一下 12563 Jin Ge Jin Qu hao (If you smiled when you see the title, this problem is for you ^_^) For those who don't know KTV, see: http://en.wikipedia.org/wiki/Karaoke_box There is one very popul

UVA 12563 Jin Ge Jin Qu hao(01背包变形:两个背包内容)

题意: KTV里面有n首歌曲你可以选择,每首歌曲的时长都给出了. 对于每首歌曲,你最多只能唱1遍. 现在给你一个时间限制t (t<=10^9) , 问你在最多t-1秒的时间内可以唱多少首歌曲num , 且最长唱歌时间是多少time (time必须<=t-1) ? 最终输出num+1 和 time+678 即可. 注意: 你需要优先让歌曲数目最大的情况下,再去选择总时长最长的. //0 KB 39 ms #include<cstdio> #include<cstring>

UVa 12563 Jin Ge Jin Qu hao(01背包)

题意  你在KTV还剩t秒钟的时间  你需要在n首歌中选择尽量多的歌使得歌的数量最多的前提下剩下的时间最小 至少要留一秒给劲歌金曲  所以是一个容量为t-1的01背包   d[i][j]表示恰用j秒时间在前i首歌中最多唱多少首  每个状态有两种选择 唱或不唱第i首歌 所以有转移方程d[i][j]=max(d[i-1][j],d[i-1][j-c[i]]+1) #include <bits/stdc++.h> using namespace std; const int N = 55, M =

UVA12563Jin Ge Jin Qu hao(01背包)

紫书P274 题意:输入N首歌曲和最后剩余的时间t,问在保证能唱的歌曲数目最多的情况下,时间最长:最后必唱<劲歌金曲> 所以就在最后一秒唱劲歌金曲就ok了,背包容量是t-1,来装前面的歌曲,设两个Time求时间,cnt是数量 #include <iostream> #include <cstring> #include <algorithm> #include <cstdio> using namespace std; const int MAX

uva 12563 - Jin Ge Jin Qu hao(动态规划~劲!歌!金!曲!)

错的我真是无语...还是状态的把握不准确.. 起始状态转移方程是很重要,但是只推出了方程是不够的 对边界状态的处理,对特殊状态的处理,这些都很重要,错了任何一个小地方,都会导致WA.... 细节!更清晰的思路,更全面的考虑! #include<cstdio> #include<cstring> #include<algorithm> using namespace std; int n,t; int v[55]; int d[55][10000]; int path[5

UVA Jin Ge Jin Qu hao 12563

Jin Ge Jin Qu hao (If you smiled when you see the title, this problem is for you ^_^) For those who don’t know KTV, see: http://en.wikipedia.org/wiki/Karaoke_box There is one very popular song called Jin Ge Jin Qu(). It is a mix of 37 songs, and is e

12563 - Jin Ge Jin Qu hao——[DP递推]

(If you smiled when you see the title, this problem is for you ^_^) For those who don’t know KTV, see: http://en.wikipedia.org/wiki/Karaoke_box There is one very popular song called Jin Ge Jin Qu(). It is a mix of 37 songs, and is extremely long (11

HDU 2955 Robberies --01背包变形

这题有些巧妙,看了别人的题解才知道做的. 因为按常规思路的话,背包容量为浮点数,,不好存储,且不能直接相加,所以换一种思路,将背包容量与价值互换,即令各银行总值为背包容量,逃跑概率(1-P)为价值,即转化为01背包问题. 此时dp[v]表示抢劫到v块钱成功逃跑的概率,概率相乘. 最后从大到小枚举v,找出概率大于逃跑概率的最大v值,即为最大抢劫的金额. 代码: #include <iostream> #include <cstdio> #include <cstring>

codeforce Gym 101102A Coins (01背包变形)

01背包变形,注意dp过程的时候就需要取膜,否则会出错. 代码如下: #include<iostream> #include<cstdio> #include<cstring> using namespace std; #define MAXW 15005 #define N 155 #define LL long long #define MOD 1000000007 int w1[N],w2[N]; LL dp1[MAXW],dp2[MAXW]; int main(

Wikioi 1025 01背包变形

这题多加了菜品必选编号,所以刚开始不知道怎么写,原来就把必选的处理下就行了,因为有重复,但是相同的价值与价格都一样,所以这里就直接挑出来就行了. 把不是必选的在里面用dp即可,dp之前也要把重复的舍去. 因为总价格容量为浮点数,所以先乘以10变成整数就可以用01背包了. #include <iostream> #include <cstdio> #include <algorithm> #include <cmath> #include <deque&